from typing import Dict, List

from riverqueue.fnv import fnv1_hash


def test_fnv1_32_bits():
    for test_str in __TEST_STRS:
        assert fnv1_hash(test_str, 32) == __FNV1_32_HASHES[test_str]


def test_fnv1_64_bits():
    for test_str in __TEST_STRS:
        assert fnv1_hash(test_str, 64) == __FNV1_64_HASHES[test_str]


#
# Test strings pulled from this test suite:
#
# https://github.com/znerol/py-fnvhash/blob/master/fnvhash/test/vector.py
#

__TEST_STRS: List[bytes] = [
    b"",
    b"a",
    b"b",
    b"c",
    b"d",
    b"e",
    b"f",
    b"fo",
    b"foo",
    b"foob",
    b"fooba",
    b"foobar",
    b"" + b"\x00",
    b"a" + b"\x00",
    b"b" + b"\x00",
    b"c" + b"\x00",
    b"d" + b"\x00",
    b"e" + b"\x00",
    b"f" + b"\x00",
    b"fo" + b"\x00",
    b"foo" + b"\x00",
    b"foob" + b"\x00",
    b"fooba" + b"\x00",
    b"foobar" + b"\x00",
    b"ch",
    b"cho",
    b"chon",
    b"chong",
    b"chongo",
    b"chongo ",
    b"chongo w",
    b"chongo wa",
    b"chongo was",
    b"chongo was ",
    b"chongo was h",
    b"chongo was he",
    b"chongo was her",
    b"chongo was here",
    b"chongo was here!",
    b"chongo was here!\n",
    b"ch" + b"\x00",
    b"cho" + b"\x00",
    b"chon" + b"\x00",
    b"chong" + b"\x00",
    b"chongo" + b"\x00",
    b"chongo " + b"\x00",
    b"chongo w" + b"\x00",
    b"chongo wa" + b"\x00",
    b"chongo was" + b"\x00",
    b"chongo was " + b"\x00",
    b"chongo was h" + b"\x00",
    b"chongo was he" + b"\x00",
    b"chongo was her" + b"\x00",
    b"chongo was here" + b"\x00",
    b"chongo was here!" + b"\x00",
    b"chongo was here!\n" + b"\x00",
    b"cu",
    b"cur",
    b"curd",
    b"curds",
    b"curds ",
    b"curds a",
    b"curds an",
    b"curds and",
    b"curds and ",
    b"curds and w",
    b"curds and wh",
    b"curds and whe",
    b"curds and whey",
    b"curds and whey\n",
    b"cu" + b"\x00",
    b"cur" + b"\x00",
    b"curd" + b"\x00",
    b"curds" + b"\x00",
    b"curds " + b"\x00",
    b"curds a" + b"\x00",
    b"curds an" + b"\x00",
    b"curds and" + b"\x00",
    b"curds and " + b"\x00",
    b"curds and w" + b"\x00",
    b"curds and wh" + b"\x00",
    b"curds and whe" + b"\x00",
    b"curds and whey" + b"\x00",
    b"curds and whey\n" + b"\x00",
    b"hi",
    b"hi" + b"\x00",
    b"hello",
    b"hello" + b"\x00",
    b"\xff\x00\x00\x01",
    b"\x01\x00\x00\xff",
    b"\xff\x00\x00\x02",
    b"\x02\x00\x00\xff",
    b"\xff\x00\x00\x03",
    b"\x03\x00\x00\xff",
    b"\xff\x00\x00\x04",
    b"\x04\x00\x00\xff",
    b"\x40\x51\x4e\x44",
    b"\x44\x4e\x51\x40",
    b"\x40\x51\x4e\x4a",
    b"\x4a\x4e\x51\x40",
    b"\x40\x51\x4e\x54",
    b"\x54\x4e\x51\x40",
    b"127.0.0.1",
    b"127.0.0.1" + b"\x00",
    b"127.0.0.2",
    b"127.0.0.2" + b"\x00",
    b"127.0.0.3",
    b"127.0.0.3" + b"\x00",
    b"64.81.78.68",
    b"64.81.78.68" + b"\x00",
    b"64.81.78.74",
    b"64.81.78.74" + b"\x00",
    b"64.81.78.84",
    b"64.81.78.84" + b"\x00",
    b"feedface",
    b"feedface" + b"\x00",
    b"feedfacedaffdeed",
    b"feedfacedaffdeed" + b"\x00",
    b"feedfacedeadbeef",
    b"feedfacedeadbeef" + b"\x00",
    b"line 1\nline 2\nline 3",
    b"chongo <Landon Curt Noll> /\\../\\",
    b"chongo <Landon Curt Noll> /\\../\\" + b"\x00",
    b"chongo (Landon Curt Noll) /\\../\\",
    b"chongo (Landon Curt Noll) /\\../\\" + b"\x00",
    b"http://antwrp.gsfc.nasa.gov/apod/astropix.html",
    b"http://en.wikipedia.org/wiki/Fowler_Noll_Vo_hash",
    b"http://epod.usra.edu/",
    b"http://exoplanet.eu/",
    b"http://hvo.wr.usgs.gov/cam3/",
    b"http://hvo.wr.usgs.gov/cams/HMcam/",
    b"http://hvo.wr.usgs.gov/kilauea/update/deformation.html",
    b"http://hvo.wr.usgs.gov/kilauea/update/images.html",
    b"http://hvo.wr.usgs.gov/kilauea/update/maps.html",
    b"http://hvo.wr.usgs.gov/volcanowatch/current_issue.html",
    b"http://neo.jpl.nasa.gov/risk/",
    b"http://norvig.com/21-days.html",
    b"http://primes.utm.edu/curios/home.php",
    b"http://slashdot.org/",
    b"http://tux.wr.usgs.gov/Maps/155.25-19.5.html",
    b"http://volcano.wr.usgs.gov/kilaueastatus.php",
    b"http://www.avo.alaska.edu/activity/Redoubt.php",
    b"http://www.dilbert.com/fast/",
    b"http://www.fourmilab.ch/gravitation/orbits/",
    b"http://www.fpoa.net/",
    b"http://www.ioccc.org/index.html",
    b"http://www.isthe.com/cgi-bin/number.cgi",
    b"http://www.isthe.com/chongo/bio.html",
    b"http://www.isthe.com/chongo/index.html",
    b"http://www.isthe.com/chongo/src/calc/lucas-calc",
    b"http://www.isthe.com/chongo/tech/astro/venus2004.html",
    b"http://www.isthe.com/chongo/tech/astro/vita.html",
    b"http://www.isthe.com/chongo/tech/comp/c/expert.html",
    b"http://www.isthe.com/chongo/tech/comp/calc/index.html",
    b"http://www.isthe.com/chongo/tech/comp/fnv/index.html",
    b"http://www.isthe.com/chongo/tech/math/number/howhigh.html",
    b"http://www.isthe.com/chongo/tech/math/number/number.html",
    b"http://www.isthe.com/chongo/tech/math/prime/mersenne.html",
    b"http://www.isthe.com/chongo/tech/math/prime/mersenne.html#largest",
    b"http://www.lavarnd.org/cgi-bin/corpspeak.cgi",
    b"http://www.lavarnd.org/cgi-bin/haiku.cgi",
    b"http://www.lavarnd.org/cgi-bin/rand-none.cgi",
    b"http://www.lavarnd.org/cgi-bin/randdist.cgi",
    b"http://www.lavarnd.org/index.html",
    b"http://www.lavarnd.org/what/nist-test.html",
    b"http://www.macosxhints.com/",
    b"http://www.mellis.com/",
    b"http://www.nature.nps.gov/air/webcams/parks/havoso2alert/havoalert.cfm",
    b"http://www.nature.nps.gov/air/webcams/parks/havoso2alert/timelines_24.cfm",
    b"http://www.paulnoll.com/",
    b"http://www.pepysdiary.com/",
    b"http://www.sciencenews.org/index/home/activity/view",
    b"http://www.skyandtelescope.com/",
    b"http://www.sput.nl/~rob/sirius.html",
    b"http://www.systemexperts.com/",
    b"http://www.tq-international.com/phpBB3/index.php",
    b"http://www.travelquesttours.com/index.htm",
    b"http://www.wunderground.com/global/stations/89606.html",
    b"21701" * 10,
    b"M21701" * 10,
    b"2^21701-1" * 10,
    b"\x54\xc5" * 10,
    b"\xc5\x54" * 10,
    b"23209" * 10,
    b"M23209" * 10,
    b"2^23209-1" * 10,
    b"\x5a\xa9" * 10,
    b"\xa9\x5a" * 10,
    b"391581216093" * 10,
    b"391581*2^216093-1" * 10,
    b"\x05\xf9\x9d\x03\x4c\x81" * 10,
    b"FEDCBA9876543210" * 10,
    b"\xfe\xdc\xba\x98\x76\x54\x32\x10" * 10,
    b"EFCDAB8967452301" * 10,
    b"\xef\xcd\xab\x89\x67\x45\x23\x01" * 10,
    b"0123456789ABCDEF" * 10,
    b"\x01\x23\x45\x67\x89\xab\xcd\xef" * 10,
    b"1032547698BADCFE" * 10,
    b"\x10\x32\x54\x76\x98\xba\xdc\xfe" * 10,
    b"\x00" * 500,
    b"\x07" * 500,
    b"~" * 500,
    b"\x7f" * 500,
]

__FNV1_32_HASHES: Dict[bytes, int] = {
    __TEST_STRS[0]: 0x811C9DC5,
    __TEST_STRS[1]: 0x050C5D7E,
    __TEST_STRS[2]: 0x050C5D7D,
    __TEST_STRS[3]: 0x050C5D7C,
    __TEST_STRS[4]: 0x050C5D7B,
    __TEST_STRS[5]: 0x050C5D7A,
    __TEST_STRS[6]: 0x050C5D79,
    __TEST_STRS[7]: 0x6B772514,
    __TEST_STRS[8]: 0x408F5E13,
    __TEST_STRS[9]: 0xB4B1178B,
    __TEST_STRS[10]: 0xFDC80FB0,
    __TEST_STRS[11]: 0x31F0B262,
    __TEST_STRS[12]: 0x050C5D1F,
    __TEST_STRS[13]: 0x70772D5A,
    __TEST_STRS[14]: 0x6F772BC7,
    __TEST_STRS[15]: 0x6E772A34,
    __TEST_STRS[16]: 0x6D7728A1,
    __TEST_STRS[17]: 0x6C77270E,
    __TEST_STRS[18]: 0x6B77257B,
    __TEST_STRS[19]: 0x408F5E7C,
    __TEST_STRS[20]: 0xB4B117E9,
    __TEST_STRS[21]: 0xFDC80FD1,
    __TEST_STRS[22]: 0x31F0B210,
    __TEST_STRS[23]: 0xFFE8D046,
    __TEST_STRS[24]: 0x6E772A5C,
    __TEST_STRS[25]: 0x4197AEBB,
    __TEST_STRS[26]: 0xFCC8100F,
    __TEST_STRS[27]: 0xFDF147FA,
    __TEST_STRS[28]: 0xBCD44EE1,
    __TEST_STRS[29]: 0x23382C13,
    __TEST_STRS[30]: 0x846D619E,
    __TEST_STRS[31]: 0x1630ABDB,
    __TEST_STRS[32]: 0xC99E89B2,
    __TEST_STRS[33]: 0x1692C316,
    __TEST_STRS[34]: 0x9F091BCA,
    __TEST_STRS[35]: 0x2556BE9B,
    __TEST_STRS[36]: 0x628E0E73,
    __TEST_STRS[37]: 0x98A0BF6C,
    __TEST_STRS[38]: 0xB10D5725,
    __TEST_STRS[39]: 0xDD002F35,
    __TEST_STRS[40]: 0x4197AED4,
    __TEST_STRS[41]: 0xFCC81061,
    __TEST_STRS[42]: 0xFDF1479D,
    __TEST_STRS[43]: 0xBCD44E8E,
    __TEST_STRS[44]: 0x23382C33,
    __TEST_STRS[45]: 0x846D61E9,
    __TEST_STRS[46]: 0x1630ABBA,
    __TEST_STRS[47]: 0xC99E89C1,
    __TEST_STRS[48]: 0x1692C336,
    __TEST_STRS[49]: 0x9F091BA2,
    __TEST_STRS[50]: 0x2556BEFE,
    __TEST_STRS[51]: 0x628E0E01,
    __TEST_STRS[52]: 0x98A0BF09,
    __TEST_STRS[53]: 0xB10D5704,
    __TEST_STRS[54]: 0xDD002F3F,
    __TEST_STRS[55]: 0x1C4A506F,
    __TEST_STRS[56]: 0x6E772A41,
    __TEST_STRS[57]: 0x26978421,
    __TEST_STRS[58]: 0xE184FF97,
    __TEST_STRS[59]: 0x9B5E5AC6,
    __TEST_STRS[60]: 0x5B88E592,
    __TEST_STRS[61]: 0xAA8164B7,
    __TEST_STRS[62]: 0x20B18C7B,
    __TEST_STRS[63]: 0xF28025C5,
    __TEST_STRS[64]: 0x84BB753F,
    __TEST_STRS[65]: 0x3219925A,
    __TEST_STRS[66]: 0x384163C6,
    __TEST_STRS[67]: 0x54F010D7,
    __TEST_STRS[68]: 0x8CEA820C,
    __TEST_STRS[69]: 0xE12AB8EE,
    __TEST_STRS[70]: 0x26978453,
    __TEST_STRS[71]: 0xE184FFF3,
    __TEST_STRS[72]: 0x9B5E5AB5,
    __TEST_STRS[73]: 0x5B88E5B2,
    __TEST_STRS[74]: 0xAA8164D6,
    __TEST_STRS[75]: 0x20B18C15,
    __TEST_STRS[76]: 0xF28025A1,
    __TEST_STRS[77]: 0x84BB751F,
    __TEST_STRS[78]: 0x3219922D,
    __TEST_STRS[79]: 0x384163AE,
    __TEST_STRS[80]: 0x54F010B2,
    __TEST_STRS[81]: 0x8CEA8275,
    __TEST_STRS[82]: 0xE12AB8E4,
    __TEST_STRS[83]: 0x64411EAA,
    __TEST_STRS[84]: 0x6977223C,
    __TEST_STRS[85]: 0x428AE474,
    __TEST_STRS[86]: 0xB6FA7167,
    __TEST_STRS[87]: 0x73408525,
    __TEST_STRS[88]: 0xB78320A1,
    __TEST_STRS[89]: 0x0CAF4135,
    __TEST_STRS[90]: 0xB78320A2,
    __TEST_STRS[91]: 0xCDC88E80,
    __TEST_STRS[92]: 0xB78320A3,
    __TEST_STRS[93]: 0x8EE1DBCB,
    __TEST_STRS[94]: 0xB78320A4,
    __TEST_STRS[95]: 0x4FFB2716,
    __TEST_STRS[96]: 0x860632AA,
    __TEST_STRS[97]: 0xCC2C5C64,
    __TEST_STRS[98]: 0x860632A4,
    __TEST_STRS[99]: 0x2A7EC4A6,
    __TEST_STRS[100]: 0x860632BA,
    __TEST_STRS[101]: 0xFEFE8E14,
    __TEST_STRS[102]: 0x0A3CFFD8,
    __TEST_STRS[103]: 0xF606C108,
    __TEST_STRS[104]: 0x0A3CFFDB,
    __TEST_STRS[105]: 0xF906C5C1,
    __TEST_STRS[106]: 0x0A3CFFDA,
    __TEST_STRS[107]: 0xF806C42E,
    __TEST_STRS[108]: 0xC07167D7,
    __TEST_STRS[109]: 0xC9867775,
    __TEST_STRS[110]: 0xBF716668,
    __TEST_STRS[111]: 0xC78435B8,
    __TEST_STRS[112]: 0xC6717155,
    __TEST_STRS[113]: 0xB99568CF,
    __TEST_STRS[114]: 0x7662E0D6,
    __TEST_STRS[115]: 0x33A7F0E2,
    __TEST_STRS[116]: 0xC2732F95,
    __TEST_STRS[117]: 0xB053E78F,
    __TEST_STRS[118]: 0x3A19C02A,
    __TEST_STRS[119]: 0xA089821E,
    __TEST_STRS[120]: 0x31AE8F83,
    __TEST_STRS[121]: 0x995FA9C4,
    __TEST_STRS[122]: 0x35983F8C,
    __TEST_STRS[123]: 0x5036A251,
    __TEST_STRS[124]: 0x97018583,
    __TEST_STRS[125]: 0xB4448D60,
    __TEST_STRS[126]: 0x025DFE59,
    __TEST_STRS[127]: 0xC5EAB3AF,
    __TEST_STRS[128]: 0x7D21BA1E,
    __TEST_STRS[129]: 0x7704CDDB,
    __TEST_STRS[130]: 0xD0071BFE,
    __TEST_STRS[131]: 0x0FF3774C,
    __TEST_STRS[132]: 0xB0FEA0EA,
    __TEST_STRS[133]: 0x58177303,
    __TEST_STRS[134]: 0x4F599CDA,
    __TEST_STRS[135]: 0x3E590A47,
    __TEST_STRS[136]: 0x965595F8,
    __TEST_STRS[137]: 0xC37F178D,
    __TEST_STRS[138]: 0x9711DD26,
    __TEST_STRS[139]: 0x23C99B7F,
    __TEST_STRS[140]: 0x6E568B17,
    __TEST_STRS[141]: 0x43F0245B,
    __TEST_STRS[142]: 0xBCB7A001,
    __TEST_STRS[143]: 0x12E6DFFE,
    __TEST_STRS[144]: 0x0792F2D6,
    __TEST_STRS[145]: 0xB966936B,
    __TEST_STRS[146]: 0x46439AC5,
    __TEST_STRS[147]: 0x728D49AF,
    __TEST_STRS[148]: 0xD33745C9,
    __TEST_STRS[149]: 0xBC382A57,
    __TEST_STRS[150]: 0x4BDA1D31,
    __TEST_STRS[151]: 0xCE35CCAE,
    __TEST_STRS[152]: 0x3B6EED94,
    __TEST_STRS[153]: 0x445C9C58,
    __TEST_STRS[154]: 0x3DB8BF9D,
    __TEST_STRS[155]: 0x2DEE116D,
    __TEST_STRS[156]: 0xC18738DA,
    __TEST_STRS[157]: 0x5B156176,
    __TEST_STRS[158]: 0x2AA7D593,
    __TEST_STRS[159]: 0xB2409658,
    __TEST_STRS[160]: 0xE1489528,
    __TEST_STRS[161]: 0xFE1EE07E,
    __TEST_STRS[162]: 0xE8842315,
    __TEST_STRS[163]: 0x3A6A63A2,
    __TEST_STRS[164]: 0x06D2C18C,
    __TEST_STRS[165]: 0xF8EF7225,
    __TEST_STRS[166]: 0x843D3300,
    __TEST_STRS[167]: 0xBB24F7AE,
    __TEST_STRS[168]: 0x878C0EC9,
    __TEST_STRS[169]: 0xB557810F,
    __TEST_STRS[170]: 0x57423246,
    __TEST_STRS[171]: 0x87F7505E,
    __TEST_STRS[172]: 0xBB809F20,
    __TEST_STRS[173]: 0x8932ABB5,
    __TEST_STRS[174]: 0x0A9B3AA0,
    __TEST_STRS[175]: 0xB8682A24,
    __TEST_STRS[176]: 0xA7AC1C56,
    __TEST_STRS[177]: 0x11409252,
    __TEST_STRS[178]: 0xA987F517,
    __TEST_STRS[179]: 0xF309E7ED,
    __TEST_STRS[180]: 0xC9E8F417,
    __TEST_STRS[181]: 0x7F447BDD,
    __TEST_STRS[182]: 0xB929ADC5,
    __TEST_STRS[183]: 0x57022879,
    __TEST_STRS[184]: 0xDCFD2C49,
    __TEST_STRS[185]: 0x6EDAFFF5,
    __TEST_STRS[186]: 0xF04FB1F1,
    __TEST_STRS[187]: 0xFB7DE8B9,
    __TEST_STRS[188]: 0xC5F1D7E9,
    __TEST_STRS[189]: 0x32C1F439,
    __TEST_STRS[190]: 0x7FD3EB7D,
    __TEST_STRS[191]: 0x81597DA5,
    __TEST_STRS[192]: 0x05EB7A25,
    __TEST_STRS[193]: 0x9C0FA1B5,
    __TEST_STRS[194]: 0x53CCB1C5,
    __TEST_STRS[195]: 0xFABECE15,
    __TEST_STRS[196]: 0x4AD745A5,
    __TEST_STRS[197]: 0xE5BDC495,
    __TEST_STRS[198]: 0x23B3C0A5,
    __TEST_STRS[199]: 0xFA823DD5,
    __TEST_STRS[200]: 0x0C6C58B9,
    __TEST_STRS[201]: 0xE2DBCCD5,
    __TEST_STRS[202]: 0xDB7F50F9,
}

__FNV1_64_HASHES: Dict[bytes, int] = {
    __TEST_STRS[0]: 0xCBF29CE484222325,
    __TEST_STRS[1]: 0xAF63BD4C8601B7BE,
    __TEST_STRS[2]: 0xAF63BD4C8601B7BD,
    __TEST_STRS[3]: 0xAF63BD4C8601B7BC,
    __TEST_STRS[4]: 0xAF63BD4C8601B7BB,
    __TEST_STRS[5]: 0xAF63BD4C8601B7BA,
    __TEST_STRS[6]: 0xAF63BD4C8601B7B9,
    __TEST_STRS[7]: 0x08326207B4EB2F34,
    __TEST_STRS[8]: 0xD8CBC7186BA13533,
    __TEST_STRS[9]: 0x0378817EE2ED65CB,
    __TEST_STRS[10]: 0xD329D59B9963F790,
    __TEST_STRS[11]: 0x340D8765A4DDA9C2,
    __TEST_STRS[12]: 0xAF63BD4C8601B7DF,
    __TEST_STRS[13]: 0x08326707B4EB37DA,
    __TEST_STRS[14]: 0x08326607B4EB3627,
    __TEST_STRS[15]: 0x08326507B4EB3474,
    __TEST_STRS[16]: 0x08326407B4EB32C1,
    __TEST_STRS[17]: 0x08326307B4EB310E,
    __TEST_STRS[18]: 0x08326207B4EB2F5B,
    __TEST_STRS[19]: 0xD8CBC7186BA1355C,
    __TEST_STRS[20]: 0x0378817EE2ED65A9,
    __TEST_STRS[21]: 0xD329D59B9963F7F1,
    __TEST_STRS[22]: 0x340D8765A4DDA9B0,
    __TEST_STRS[23]: 0x50A6D3B724A774A6,
    __TEST_STRS[24]: 0x08326507B4EB341C,
    __TEST_STRS[25]: 0xD8D5C8186BA98BFB,
    __TEST_STRS[26]: 0x1CCEFC7EF118DBEF,
    __TEST_STRS[27]: 0x0C92FAB3AD3DB77A,
    __TEST_STRS[28]: 0x9B77794F5FDEC421,
    __TEST_STRS[29]: 0x0AC742DFE7874433,
    __TEST_STRS[30]: 0xD7DAD5766AD8E2DE,
    __TEST_STRS[31]: 0xA1BB96378E897F5B,
    __TEST_STRS[32]: 0x5B3F9B6733A367D2,
    __TEST_STRS[33]: 0xB07CE25CBEA969F6,
    __TEST_STRS[34]: 0x8D9E9997F9DF0D6A,
    __TEST_STRS[35]: 0x838C673D9603CB7B,
    __TEST_STRS[36]: 0x8B5EE8A5E872C273,
    __TEST_STRS[37]: 0x4507C4E9FB00690C,
    __TEST_STRS[38]: 0x4C9CA59581B27F45,
    __TEST_STRS[39]: 0xE0ACA20B624E4235,
    __TEST_STRS[40]: 0xD8D5C8186BA98B94,
    __TEST_STRS[41]: 0x1CCEFC7EF118DB81,
    __TEST_STRS[42]: 0x0C92FAB3AD3DB71D,
    __TEST_STRS[43]: 0x9B77794F5FDEC44E,
    __TEST_STRS[44]: 0x0AC742DFE7874413,
    __TEST_STRS[45]: 0xD7DAD5766AD8E2A9,
    __TEST_STRS[46]: 0xA1BB96378E897F3A,
    __TEST_STRS[47]: 0x5B3F9B6733A367A1,
    __TEST_STRS[48]: 0xB07CE25CBEA969D6,
    __TEST_STRS[49]: 0x8D9E9997F9DF0D02,
    __TEST_STRS[50]: 0x838C673D9603CB1E,
    __TEST_STRS[51]: 0x8B5EE8A5E872C201,
    __TEST_STRS[52]: 0x4507C4E9FB006969,
    __TEST_STRS[53]: 0x4C9CA59581B27F64,
    __TEST_STRS[54]: 0xE0ACA20B624E423F,
    __TEST_STRS[55]: 0x13998E580AFA800F,
    __TEST_STRS[56]: 0x08326507B4EB3401,
    __TEST_STRS[57]: 0xD8D5AD186BA95DC1,
    __TEST_STRS[58]: 0x1C72E17EF0CA4E97,
    __TEST_STRS[59]: 0x2183C1B327C38AE6,
    __TEST_STRS[60]: 0xB66D096C914504F2,
    __TEST_STRS[61]: 0x404BF57AD8476757,
    __TEST_STRS[62]: 0x887976BD815498BB,
    __TEST_STRS[63]: 0x3AFD7F02C2BF85A5,
    __TEST_STRS[64]: 0xFC4476B0EB70177F,
    __TEST_STRS[65]: 0x186D2DA00F77ECBA,
    __TEST_STRS[66]: 0xF97140FA48C74066,
    __TEST_STRS[67]: 0xA2B1CF49AA926D37,
    __TEST_STRS[68]: 0x0690712CD6CF940C,
    __TEST_STRS[69]: 0xF7045B3102B8906E,
    __TEST_STRS[70]: 0xD8D5AD186BA95DB3,
    __TEST_STRS[71]: 0x1C72E17EF0CA4EF3,
    __TEST_STRS[72]: 0x2183C1B327C38A95,
    __TEST_STRS[73]: 0xB66D096C914504D2,
    __TEST_STRS[74]: 0x404BF57AD8476736,
    __TEST_STRS[75]: 0x887976BD815498D5,
    __TEST_STRS[76]: 0x3AFD7F02C2BF85C1,
    __TEST_STRS[77]: 0xFC4476B0EB70175F,
    __TEST_STRS[78]: 0x186D2DA00F77ECCD,
    __TEST_STRS[79]: 0xF97140FA48C7400E,
    __TEST_STRS[80]: 0xA2B1CF49AA926D52,
    __TEST_STRS[81]: 0x0690712CD6CF9475,
    __TEST_STRS[82]: 0xF7045B3102B89064,
    __TEST_STRS[83]: 0x74F762479F9D6AEA,
    __TEST_STRS[84]: 0x08326007B4EB2B9C,
    __TEST_STRS[85]: 0xD8C4C9186B9B1A14,
    __TEST_STRS[86]: 0x7B495389BDBDD4C7,
    __TEST_STRS[87]: 0x3B6DBA0D69908E25,
    __TEST_STRS[88]: 0xD6B2B17BF4B71261,
    __TEST_STRS[89]: 0x447BFB7F98E615B5,
    __TEST_STRS[90]: 0xD6B2B17BF4B71262,
    __TEST_STRS[91]: 0x3BD2807F93FE1660,
    __TEST_STRS[92]: 0xD6B2B17BF4B71263,
    __TEST_STRS[93]: 0x3329057F8F16170B,
    __TEST_STRS[94]: 0xD6B2B17BF4B71264,
    __TEST_STRS[95]: 0x2A7F8A7F8A2E19B6,
    __TEST_STRS[96]: 0x23D3767E64B2F98A,
    __TEST_STRS[97]: 0xFF768D7E4F9D86A4,
    __TEST_STRS[98]: 0x23D3767E64B2F984,
    __TEST_STRS[99]: 0xCCD1837E334E4AA6,
    __TEST_STRS[100]: 0x23D3767E64B2F99A,
    __TEST_STRS[101]: 0x7691FD7E028F6754,
    __TEST_STRS[102]: 0x34AD3B1041204318,
    __TEST_STRS[103]: 0xA29E749EA9D201C8,
    __TEST_STRS[104]: 0x34AD3B104120431B,
    __TEST_STRS[105]: 0xA29E779EA9D206E1,
    __TEST_STRS[106]: 0x34AD3B104120431A,
    __TEST_STRS[107]: 0xA29E769EA9D2052E,
    __TEST_STRS[108]: 0x02A17EBCA4AA3497,
    __TEST_STRS[109]: 0x229EF18BCD375C95,
    __TEST_STRS[110]: 0x02A17DBCA4AA32C8,
    __TEST_STRS[111]: 0x229B6F8BCD3449D8,
    __TEST_STRS[112]: 0x02A184BCA4AA3ED5,
    __TEST_STRS[113]: 0x22B3618BCD48C3EF,
    __TEST_STRS[114]: 0x5C2C346706186F36,
    __TEST_STRS[115]: 0xB78C410F5B84F8C2,
    __TEST_STRS[116]: 0xED9478212B267395,
    __TEST_STRS[117]: 0xD9BBB55C5256662F,
    __TEST_STRS[118]: 0x8C54F0203249438A,
    __TEST_STRS[119]: 0xBD9790B5727DC37E,
    __TEST_STRS[120]: 0xA64E5F36C9E2B0E3,
    __TEST_STRS[121]: 0x8FD0680DA3088A04,
    __TEST_STRS[122]: 0x67AAD32C078284CC,
    __TEST_STRS[123]: 0xB37D55D81C57B331,
    __TEST_STRS[124]: 0x55AC0F3829057C43,
    __TEST_STRS[125]: 0xCB27F4B8E1B6CC20,
    __TEST_STRS[126]: 0x26CAF88BCBEF2D19,
    __TEST_STRS[127]: 0x8E6E063B97E61B8F,
    __TEST_STRS[128]: 0xB42750F7F3B7C37E,
    __TEST_STRS[129]: 0xF3C6BA64CF7CA99B,
    __TEST_STRS[130]: 0xEBFB69B427EA80FE,
    __TEST_STRS[131]: 0x39B50C3ED970F46C,
    __TEST_STRS[132]: 0x5B9B177AA3EB3E8A,
    __TEST_STRS[133]: 0x6510063ECF4EC903,
    __TEST_STRS[134]: 0x2B3BBD2C00797C7A,
    __TEST_STRS[135]: 0xF1D6204FF5CB4AA7,
    __TEST_STRS[136]: 0x4836E27CCF099F38,
    __TEST_STRS[137]: 0x82EFBB0DD073B44D,
    __TEST_STRS[138]: 0x4A80C282FFD7D4C6,
    __TEST_STRS[139]: 0x305D1A9C9EE43BDF,
    __TEST_STRS[140]: 0x15C366948FFC6997,
    __TEST_STRS[141]: 0x80153AE218916E7B,
    __TEST_STRS[142]: 0xFA23E2BDF9E2A9E1,
    __TEST_STRS[143]: 0xD47E8D8A2333C6DE,
    __TEST_STRS[144]: 0x7E128095F688B056,
    __TEST_STRS[145]: 0x2F5356890EFCEDAB,
    __TEST_STRS[146]: 0x95C2B383014F55C5,
    __TEST_STRS[147]: 0x4727A5339CE6070F,
    __TEST_STRS[148]: 0xB0555ECD575108E9,
    __TEST_STRS[149]: 0x48D785770BB4AF37,
    __TEST_STRS[150]: 0x09D4701C12AF02B1,
    __TEST_STRS[151]: 0x79F031E78F3CF62E,
    __TEST_STRS[152]: 0x52A1EE85DB1B5A94,
    __TEST_STRS[153]: 0x6BD95B2EB37FA6B8,
    __TEST_STRS[154]: 0x74971B7077AEF85D,
    __TEST_STRS[155]: 0xB4E4FAE2FFCC1AAD,
    __TEST_STRS[156]: 0x2BD48BD898B8F63A,
    __TEST_STRS[157]: 0xE9966AC1556257F6,
    __TEST_STRS[158]: 0x92A3D1CD078BA293,
    __TEST_STRS[159]: 0xF81175A482E20AB8,
    __TEST_STRS[160]: 0x5BBB3DE722E73048,
    __TEST_STRS[161]: 0x6B4F363492B9F2BE,
    __TEST_STRS[162]: 0xC2D559DF73D59875,
    __TEST_STRS[163]: 0xF75F62284BC7A8C2,
    __TEST_STRS[164]: 0xDA8DD8E116A9F1CC,
    __TEST_STRS[165]: 0xBDC1E6AB76057885,
    __TEST_STRS[166]: 0xFEC6A4238A1224A0,
    __TEST_STRS[167]: 0xC03F40F3223E290E,
    __TEST_STRS[168]: 0x1ED21673466FFDA9,
    __TEST_STRS[169]: 0xDF70F906BB0DD2AF,
    __TEST_STRS[170]: 0xF3DCDA369F2AF666,
    __TEST_STRS[171]: 0x9EBB11573CDCEBDE,
    __TEST_STRS[172]: 0x81C72D9077FEDCA0,
    __TEST_STRS[173]: 0x0EC074A31BE5FB15,
    __TEST_STRS[174]: 0x2A8B3280B6C48F20,
    __TEST_STRS[175]: 0xFD31777513309344,
    __TEST_STRS[176]: 0x194534A86AD006B6,
    __TEST_STRS[177]: 0x3BE6FDF46E0CFE12,
    __TEST_STRS[178]: 0x017CC137A07EB057,
    __TEST_STRS[179]: 0x9428FC6E7D26B54D,
    __TEST_STRS[180]: 0x9AAA2E3603EF8AD7,
    __TEST_STRS[181]: 0x82C6D3F3A0CCDF7D,
    __TEST_STRS[182]: 0xC86EEEA00CF09B65,
    __TEST_STRS[183]: 0x705F8189DBB58299,
    __TEST_STRS[184]: 0x415A7F554391CA69,
    __TEST_STRS[185]: 0xCFE3D49FA2BDC555,
    __TEST_STRS[186]: 0xF0F9C56039B25191,
    __TEST_STRS[187]: 0x7075CB6ABD1D32D9,
    __TEST_STRS[188]: 0x43C94E2C8B277509,
    __TEST_STRS[189]: 0x3CBFD4E4EA670359,
    __TEST_STRS[190]: 0xC05887810F4D019D,
    __TEST_STRS[191]: 0x14468FF93AC22DC5,
    __TEST_STRS[192]: 0xEBED699589D99C05,
    __TEST_STRS[193]: 0x6D99F6DF321CA5D5,
    __TEST_STRS[194]: 0x0CD410D08C36D625,
    __TEST_STRS[195]: 0xEF1B2A2C86831D35,
    __TEST_STRS[196]: 0x3B349C4D69EE5F05,
    __TEST_STRS[197]: 0x55248CE88F45F035,
    __TEST_STRS[198]: 0xAA69CA6A18A4C885,
    __TEST_STRS[199]: 0x1FE3FCE62BD816B5,
    __TEST_STRS[200]: 0x0289A488A8DF69D9,
    __TEST_STRS[201]: 0x15E96E1613DF98B5,
    __TEST_STRS[202]: 0xE6BE57375AD89B99,
}
